import java.util.HashMap;

import com.ibm.j2ca.base.exceptions.InvalidObjectDefinitionException;
import com.ibm.j2ca.base.internal.WPSServiceHelper;
import com.ibm.websphere.sca.Service;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;
import commonj.sdo.Property;


public class Output_Processing {
	/**
	 * Default constructor.
	 */
	public Output_Processing() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * This method is used to locate the service for the reference
	 * named "Output".  This will return an instance of
	 * {@link com.ibm.websphere.sca.Service}.  This is the dynamic
	 * interface which is used to invoke operations on the reference service
	 * either synchronously or asynchronously.  You will need to pass the operation
	 * name in order to invoke an operation on the service.
	 *
	 * @generated (com.ibm.wbit.java)
	 *
	 * @return Service
	 */
	public Service locateService_Output() {
		return (Service) ServiceManager.INSTANCE.locateService("Output");
	}

	private String getVerb(DataObject dataObject) {
		String verb = null;
		try {
			verb = WPSServiceHelper.getTopLevelVerb(dataObject);
		} catch (InvalidObjectDefinitionException e) {
			verb = null;
		}
		return verb;
	}

	private String getOperation(String verb, DataObject dataObject)throws Exception {

		//JCA Email outbound only supports 'Create' verb. The operation name is fixed.
		String operation = "sendEmail";
		return operation;

	}	
	
	private DataObject getInputType(String verb,DataObject orgInputType){
		HashMap<String,String> attributeMap = new HashMap<String,String>(); 
		// WBI Property -> JCA Property
		attributeMap.put("FromAddress", "From");
		attributeMap.put("RecipientName", "To");
//		attributeMap.put("RecipientName", "CC");
//		attributeMap.put("RecipientName", "BCC");
		attributeMap.put("MessageSubject", "Subject");
		attributeMap.put("ReplyTo", "Reply-To");
		attributeMap.put("MessageContentMimeCharset", "Encoding");		
	
		DataObject newInputType = WPSServiceHelper.createDataObject("http://www.ibm.com/xmlns/prod/websphere/j2ca/email/email", "Email");
		DataObject topLevelBO = orgInputType.getDataObject(orgInputType.getType().getName().replace("BG", ""));
		
		for(Object wbiProp: topLevelBO.getType().getProperties()){
			String wbiPropName = ((Property)wbiProp).getName();
			if( !((Property)wbiProp).isContainment() ){//is simple type
				String wbiPropValue = topLevelBO.getString(wbiPropName);
				if(wbiPropValue==null || wbiPropValue==""){
					continue;
				}
				if(attributeMap.containsKey(wbiPropName)){
					newInputType.setString(attributeMap.get(wbiPropName), wbiPropValue);
					//CR93084 - Set the value for CC and BCC.
					if(wbiPropName.equalsIgnoreCase("RecipientName")){
						newInputType.setString("CC", wbiPropValue); 
						newInputType.setString("BCC", wbiPropValue); 
					}
				}else if(wbiPropName.equalsIgnoreCase("MessageContent")){
					DataObject unstrutureContent = WPSServiceHelper.createDataObject("http://www.ibm.com/xmlns/prod/websphere/j2ca/base/unstructuredcontent", "UnstructuredContent");
					unstrutureContent.setString("AsText", wbiPropValue);
					newInputType.setDataObject("mailContent", unstrutureContent);
				}
			}else{//is child bo type
				DataObject wbiPropValue = topLevelBO.getDataObject(wbiPropName);
				if(wbiPropValue == null){
					continue;
				}
				DataObject mailAttachment = WPSServiceHelper.createDataObject("http://www.ibm.com/xmlns/prod/websphere/j2ca/email/mailattachment", "MailAttachment");
				mailAttachment.setString("attachmentName", wbiPropName);
				mailAttachment.setDataObject("appBOData", wbiPropValue);
				newInputType.getList("mailAttachments").add(mailAttachment);
			}
		}		
		return newInputType;
	}
	
}