/* IBM Confidential
 * OCO Source Materials
 * 5724-N40, 5724-N41, 5724-N42, 5724-N43, 5724-L77, 5724-L78, 5724-L79, 5724-L80, 5724-L81, 5724-L82
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
package com.ibm.j2ca.migration.sap.v602_to_v610;

import java.util.ArrayList;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import com.ibm.j2ca.migration.IChange;
import com.ibm.j2ca.migration.changedata.ModuleChangeData;
import com.ibm.j2ca.migration.changedata.wbi.ConvertWBIASItoJCA;
import com.ibm.j2ca.migration.internal.changes.wbi.ConvertWBIASItoJCAASIChange;
import com.ibm.j2ca.migration.util.AttributeMap;
import com.ibm.j2ca.migration.util.SearchHelper;

public class AddqRFCQueueNameASIForSAP extends ModuleChangeData {
	public static final String COPYRIGHT = " Copyright IBM Corporation 2008."; //$NON-NLS-1$

	public String boMetadataNodeName;
	public String attributeMetadataNodeName;
	public AttributeMap<String> asiMap;
	public String sapAPI = "";
	
	public ArrayList<IChange> createChanges(IResource resource, ModuleType[] projectModuleTypes) {
		ArrayList<IChange> changes = new ArrayList<IChange>();
		if(resource instanceof IProject) {
			IProject project = (IProject)resource;
			
			ArrayList<IFile> boList = new ArrayList<IFile>();
			try {
				boList = SearchHelper.getTopLevelBOs(project);
			} catch(Exception e) {}
			
            for(IFile file : boList)  {					
				changes.add(new AddqRFCQueueNameASIForSAPChange(file, this));
			}
		}
		return changes;
	}
}
