/* IBM Confidential
 * OCO Source Materials
 * 5724-N40, 5724-N41, 5724-N42, 5724-N43, 5724-L77, 5724-L78, 5724-L79, 5724-L80, 5724-L81, 5724-L82
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */
package com.ibm.j2ca.migration.sap.wbi_to_v610;

import java.io.IOException;
import java.util.ArrayList;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.xml.sax.SAXException;

import com.ibm.j2ca.migration.IChange;
import com.ibm.j2ca.migration.MigrationException;
import com.ibm.j2ca.migration.changedata.ModuleChangeData;
import com.ibm.j2ca.migration.changedata.wbi.ConvertWBIASItoJCA;
import com.ibm.j2ca.migration.internal.changes.wbi.ConvertWBIASItoJCAASIChange;
import com.ibm.j2ca.migration.util.AttributeMap;
import com.ibm.j2ca.migration.util.SearchHelper;

public class DeleteRenameBOForBAPIRS extends ModuleChangeData {
	public static final String COPYRIGHT = " Copyright IBM Corporation 2008."; //$NON-NLS-1$

	public String sapAPI = "";
	public String keyPairsSplitRegEx = ";";
	public boolean isRenameBack = false;
	
	public DeleteRenameBOForBAPIRS(String sapAPI) {
		this.sapAPI = sapAPI;
	}
	
	public ArrayList<IChange> createChanges(IResource resource, ModuleType[] projectModuleTypes)  {
		ArrayList<IChange> changes = new ArrayList<IChange>();
		if(resource instanceof IFile) {
			IFile file = (IFile)resource;
			ArrayList<IFile> boFiles = null;
			try {
			   boFiles = SearchHelper.getSupportedBOs(file.getProject());
			}catch(Exception e){}
			if(boFiles!=null)
			  for(IFile oneFile : boFiles) {
			    if(file.getLocation().toString().equals(oneFile.getLocation().toString()))					
				   changes.add(new DeleteRenameBOForBAPIRSChange(file, this));
			   }
		}
		return changes;
	}
}
