/* IBM Confidential
 * OCO Source Materials
 * 5724-N40, 5724-N41, 5724-N42, 5724-N43, 5724-L77, 5724-L78, 5724-L79, 5724-L80, 5724-L81, 5724-L82
 *  Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
 */

package com.ibm.j2ca.migration.sap.wbi_to_v610;

import java.util.ArrayList;
import java.util.Hashtable;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;

import com.ibm.j2ca.migration.IChange;
import com.ibm.j2ca.migration.changedata.wbi.ImportWBIProperties;
import com.ibm.j2ca.migration.util.Util;

public class ImportWBIPropertiesForSAP extends ImportWBIProperties {
	public static final String COPYRIGHT = " Copyright IBM Corporation 2008."; //$NON-NLS-1$

	public ImportWBIPropertiesForSAP(Hashtable<String, String> importPropertyMap, ServiceType [] services) {
		super(importPropertyMap, services);
	}

	public ArrayList<IChange> createChanges(IResource resource, ModuleType [] projectModuleTypes) {
		ArrayList<IChange> changes = new ArrayList<IChange>();
		if(resource instanceof IFile) {
			IFile file = (IFile)resource;
			configFile = Util.getWBIConfigFile(file.getProject());
			if(matchesService(file, services) && configFile!=null) {
				changes.add(new ImportWBIPropertiesForSAPChange(file, this));
			}
		}
		return changes;
	}

}
